OnDutyPlayers = {}
OnDutyPlayerBlips = {}
local dptCategory = 'none'

-------------
-- THREADS --
-------------

CreateThread(function()
    Citizen.Trace("\n~g~[krypton-leo Duty]: ~w~Adding Chat Suggestions for krypton-leo Duty\n")
    TriggerEvent('chat:addSuggestion', '/leoduty', 'Go on duty as your leo department', {{ name="department", help="The Department example: BCSO"}, { name="callsign", help="Your Assigned Callsign example: 2C-21"}})
end)

------------
-- EVENTS --
------------

RegisterNetEvent('krypton-leo-duty:updateOnDutyPlayers')
AddEventHandler('krypton-leo-duty:updateOnDutyPlayers', function(players)
    OnDutyPlayers = players
end)

AddEventHandler('playerDropped', function(reason)
    local source = source
    TriggerServerEvent('krypton-leo-duty:offDuty')
end)

RegisterNetEvent('krypton-leo-duty:enableblips')
AddEventHandler('krypton-leo-duty:enableblips', function(selectedCategory)
    dptCategory = selectedCategory
end)

RegisterNetEvent('krypton-leo-duty:disableblips')
AddEventHandler('krypton-leo-duty:disableblips', function()
    dptCategory = 'none'
    for _,info in pairs(OnDutyPlayerBlips) do
        if info.blip then
            RemoveBlip(info.blip)
        end
    end
    OnDutyPlayerBlips = {}
end)

RegisterNetEvent('krypton-leo-duty:updateblips')
AddEventHandler('krypton-leo-duty:updateblips', function(list)
    local idsOnline = {}
    for i = 1, #list do
        local add = true
        local myID = GetPlayerServerId(PlayerId())
        local pID = list[i]['svid']
        if tonumber(pID) == myID then
            add = false
        end
        if add then
            table.insert(idsOnline,pID)
            local pName = list[i]['name']
            local pX = list[i]['x']
            local pY = list[i]['y']
            local pZ = list[i]['z']
            local hdg = list[i]['hdg']
            local color = list[i]['color']
            local category = list[i]['category']
            if "STAFF" == dptCategory then
                if not OnDutyPlayerBlips[pID] then
                    OnDutyPlayerBlips[pID] = {}
                    OnDutyPlayerBlips[pID] = {title = pName, colour = color, id = 1, x = pX, y = pY, z = pZ, heading = hdg}
                    newBlip(pID, OnDutyPlayerBlips[pID])
                else
                    updateBlip(pID,pX,pY,pZ,hdg)
                end
            else
                if not (category == "STAFF") then
                    if not OnDutyPlayerBlips[pID] then
                        OnDutyPlayerBlips[pID] = {}
                        OnDutyPlayerBlips[pID] = {title = pName, colour = color, id = 1, x = pX, y = pY, z = pZ, heading = hdg}
                        newBlip(pID, OnDutyPlayerBlips[pID])
                    else
                        updateBlip(pID,pX,pY,pZ,hdg)
                    end
                end
            end
            
        end
    end
    for id, _ in pairs(OnDutyPlayerBlips) do
        local found = false
        for _, id2 in pairs(idsOnline) do
            if id2 == id then
                found = true
            end
        end
        if not found then
            RemoveBlip(OnDutyPlayerBlips[id]['blip'])
            OnDutyPlayerBlips[id] = nil
        end
    end
end)

function updateBlip(id,x,y,z,hdg)
    if OnDutyPlayerBlips[id] then
        SetBlipCoords(OnDutyPlayerBlips[id]['blip'],x,y,z)
        OnDutyPlayerBlips[id].x = x
        OnDutyPlayerBlips[id].y = y
        OnDutyPlayerBlips[id].z = z
        SetBlipRotation(OnDutyPlayerBlips[id]['blip'], hdg)
    end
end


function newBlip(id, info)
    CreateThread(function()
        OnDutyPlayerBlips[id]['blip'] = AddBlipForCoord(info.x, info.y, info.z)
        SetBlipSprite(OnDutyPlayerBlips[id]['blip'], info.id)
        SetBlipCategory(OnDutyPlayerBlips[id]['blip'], 7)
        SetBlipDisplay(OnDutyPlayerBlips[id]['blip'], 4)
        SetBlipScale(OnDutyPlayerBlips[id]['blip'], 0.9)
        SetBlipColour(OnDutyPlayerBlips[id]['blip'], info.colour)
        SetBlipAsShortRange(OnDutyPlayerBlips[id]['blip'], true)
        ShowHeadingIndicatorOnBlip(OnDutyPlayerBlips[id]['blip'], true)
        SetBlipRotation(OnDutyPlayerBlips[id]['blip'], info.heading)
        BeginTextCommandSetBlipName("STRING")
        AddTextComponentString(info.title)
        EndTextCommandSetBlipName(OnDutyPlayerBlips[id]['blip'])
    end)
end