<?php
include('db.php');

// Get the user ID from the request
$user_id = $_GET['user_id'];

// Fetch products assigned to the user
$stmt = $pdo->prepare("SELECT p.id, p.name 
                       FROM products p
                       INNER JOIN whitelist w ON p.id = w.product_id
                       WHERE w.user_id = :user_id");
$stmt->bindParam(':user_id', $user_id);
$stmt->execute();
$products = $stmt->fetchAll(PDO::FETCH_ASSOC);

// Return the products as a JSON response
echo json_encode(['products' => $products]);
